searchData={"items":[{"type":"behaviour","title":"AshArchival.ArchiveRelatedArguments","doc":"The behaviour for specifiying arguments for related resources","ref":"AshArchival.ArchiveRelatedArguments.html"},{"type":"callback","title":"AshArchival.ArchiveRelatedArguments.arguments/3","doc":"","ref":"AshArchival.ArchiveRelatedArguments.html#c:arguments/3"},{"type":"module","title":"AshArchival","doc":"An Archival extension for `Ash.Resource`","ref":"AshArchival.html"},{"type":"module","title":"AshArchival.Resource","doc":"Configures a resource to be archived instead of destroyed for all destroy actions.\n\nFor more information, see [the getting started guide](/documentation/tutorials/get-started-with-ash-archival.md)","ref":"AshArchival.Resource.html"},{"type":"macro","title":"AshArchival.Resource.archive/1","doc":"","ref":"AshArchival.Resource.html#archive/1"},{"type":"module","title":"AshArchival.Resource.Info","doc":"Introspection helpers for `AshArchival.Resource`","ref":"AshArchival.Resource.Info.html"},{"type":"function","title":"AshArchival.Resource.Info.archive_archive_related/1","doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.","ref":"AshArchival.Resource.Info.html#archive_archive_related/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_archive_related!/1","doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.","ref":"AshArchival.Resource.Info.html#archive_archive_related!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_archive_related_arguments/1","doc":"A function to allow passing along some of the arguments to related resources when archiving them.","ref":"AshArchival.Resource.Info.html#archive_archive_related_arguments/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_archive_related_arguments!/1","doc":"A function to allow passing along some of the arguments to related resources when archiving them.","ref":"AshArchival.Resource.Info.html#archive_archive_related_arguments!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_archive_related_authorize?/1","doc":"Whether or not to run authorization checks when reading and archiving related records.","ref":"AshArchival.Resource.Info.html#archive_archive_related_authorize?/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_attribute/1","doc":"The attribute in which to store the archival flag (the current datetime).","ref":"AshArchival.Resource.Info.html#archive_attribute/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_attribute!/1","doc":"The attribute in which to store the archival flag (the current datetime).","ref":"AshArchival.Resource.Info.html#archive_attribute!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_attribute_type/1","doc":"The attribute type.","ref":"AshArchival.Resource.Info.html#archive_attribute_type/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_attribute_type!/1","doc":"The attribute type.","ref":"AshArchival.Resource.Info.html#archive_attribute_type!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_base_filter?/1","doc":"Whether or not a base filter exists that applies the `is_nil(archived_at)` rule.","ref":"AshArchival.Resource.Info.html#archive_base_filter?/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_destroy_actions/1","doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.","ref":"AshArchival.Resource.Info.html#archive_exclude_destroy_actions/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_destroy_actions!/1","doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.","ref":"AshArchival.Resource.Info.html#archive_exclude_destroy_actions!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_read_actions/1","doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.","ref":"AshArchival.Resource.Info.html#archive_exclude_read_actions/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_read_actions!/1","doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.","ref":"AshArchival.Resource.Info.html#archive_exclude_read_actions!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_upsert_actions/1","doc":"This option is deprecated as it no longer has any effect. Upserts are handled according to the upsert identity. See the upserts guide for more.","ref":"AshArchival.Resource.Info.html#archive_exclude_upsert_actions/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_exclude_upsert_actions!/1","doc":"This option is deprecated as it no longer has any effect. Upserts are handled according to the upsert identity. See the upserts guide for more.","ref":"AshArchival.Resource.Info.html#archive_exclude_upsert_actions!/1"},{"type":"function","title":"AshArchival.Resource.Info.archive_options/1","doc":"archive DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshArchival.Resource.Info.html#archive_options/1"},{"type":"extras","title":"Home","doc":"![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-black-text.png?raw=true#gh-light-mode-only)\n![Logo](https://github.com/ash-project/ash/blob/main/logos/cropped-for-header-white-text.png?raw=true#gh-dark-mode-only)\n\n![Elixir CI](https://github.com/ash-project/ash_archival/workflows/CI/badge.svg)\n[![License: MIT](https://img.shields.io/badge/License-MIT-yellow.svg)](https://opensource.org/licenses/MIT)\n[![Hex version badge](https://img.shields.io/hexpm/v/ash_archival.svg)](https://hex.pm/packages/ash_archival)\n[![Hexdocs badge](https://img.shields.io/badge/docs-hexdocs-purple)](https://hexdocs.pm/ash_archival)\n\n# AshArchival\n\nAshArchival is an [Ash](https://hexdocs.pm/ash) extension that provides a push-button solution for soft deleting records, instead of destroying them.","ref":"readme.html"},{"type":"extras","title":"Tutorials - Home","doc":"- [Get Started with AshArchival](documentation/tutorials/get-started-with-ash-archival.md)","ref":"readme.html#tutorials"},{"type":"extras","title":"Topics - Home","doc":"- [How does AshArchival work?](documentation/topics/how-does-ash-archival-work.md)\n- [Unarchiving](documentation/topics/unarchiving.md)\n- [Upgrading to 2.0](documentation/topics/upgrading-to-2.0.md)","ref":"readme.html#topics"},{"type":"extras","title":"Reference - Home","doc":"- [AshArchival DSL](documentation/dsls/DSL-AshArchival.Resource.md)","ref":"readme.html#reference"},{"type":"extras","title":"Change Log","doc":"# Change Log\n\nAll notable changes to this project will be documented in this file.\nSee [Conventional Commits](Https://conventionalcommits.org) for commit guidelines.\n\n<!-- changelog -->\n\n## [v2.0.0](https://github.com/ash-project/ash_archival/compare/v1.1.2...v2.0.0) (2025-06-20)","ref":"changelog.html"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"* add `archive_related_authorize?`, and default it to `true` by Zach Daniel\n\n\n\n## [v1.1.2](https://github.com/ash-project/ash_archival/compare/v1.1.1...v1.1.2) (2025-03-25)","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* missing tenant in related_query/2 of ArchiveRelated (#118)\n\n## [v1.1.1](https://github.com/ash-project/ash_archival/compare/v1.1.0...v1.1.1) (2025-02-11)","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* pass tenant to load in archive related (#101)\n\n* set relationship context on bulk destroy\n\n## [v1.1.0](https://github.com/ash-project/ash_archival/compare/v1.0.4...v1.1.0) (2025-01-27)","ref":"changelog.html#bug-fixes-1"},{"type":"extras","title":"Features: - Change Log","doc":"* allow passing of arguments to related resources (#93)","ref":"changelog.html#features"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* credo\n\n## [v1.0.4](https://github.com/ash-project/ash_archival/compare/v1.0.3...v1.0.4) (2024-10-07)","ref":"changelog.html#bug-fixes-2"},{"type":"extras","title":"Improvements: - Change Log","doc":"* Add attribute_type to configure archived_at timestamp (#56)\n\n## [v1.0.3](https://github.com/ash-project/ash_archival/compare/v1.0.2...v1.0.3) (2024-08-16)","ref":"changelog.html#improvements"},{"type":"extras","title":"Improvements: - Change Log","doc":"* deprecate exclude_upsert_actions, as it had unintended side effects\n\n* add `exclude_upsert_actions` configuration\n\n## [v1.0.2](https://github.com/ash-project/ash_archival/compare/v1.0.1...v1.0.2) (2024-07-11)","ref":"changelog.html#improvements-1"},{"type":"extras","title":"Improvements: - Change Log","doc":"* only add archive attribute if it doesn't already exists\n\n## [v1.0.1](https://github.com/ash-project/ash_archival/compare/v1.0.0...v1.0.1) (2024-06-23)","ref":"changelog.html#improvements-2"},{"type":"extras","title":"Bug Fixes: - Change Log","doc":"* set `ash_archival` on the bulk destroy read query\n\n* ensure `ash_archival: true` is set on all destroy invocations","ref":"changelog.html#bug-fixes-3"},{"type":"extras","title":"Improvements: - Change Log","doc":"* update ash for `atomic_upgrade_with` feature\n\n## [v1.0.0](https://github.com/ash-project/ash_archival/compare/v1.0.0...v1.0.0) (2024-05-10)","ref":"changelog.html#improvements-3"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support `base_filter? true` option\n\n## [v1.0.0](https://github.com/ash-project/ash_archival/compare/v1.0.0...v1.0.0) (2024-05-10)","ref":"changelog.html#improvements-4"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support `base_filter? true` option\n\n## [v1.0.0](https://github.com/ash-project/ash_archival/compare/v1.0.0-rc.1...v1.0.0) (2024-05-10)","ref":"changelog.html#improvements-5"},{"type":"extras","title":"Improvements: - Change Log","doc":"* support `base_filter? true` option\n\n## [v1.0.0](https://github.com/ash-project/ash_archival/compare/v1.0.0-rc.0...v0.1.5)\n\nThe changelog is being restarted. See `/documentation/0.x-CHANGELOG.md` in GitHub for previous changelogs.","ref":"changelog.html#improvements-6"},{"type":"extras","title":"Breaking Changes: - Change Log","doc":"- [AshArchival] don't use `base_filter` anymore, allowing for more flexible design","ref":"changelog.html#breaking-changes-1"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [AshArchival] support filters on upsert actions","ref":"changelog.html#improvements-7"},{"type":"extras","title":"Improvements: - Change Log","doc":"- [AshArchival] rewritten to support atomics & bulk actions to take advantage of new bulk actions\n- [AshArchival] add `exclude_read_actions` to exclude some actions from filtering archived items\n- [AshArchival] add `exclude_destroy_actions` to exclude some actions from being intercepted","ref":"changelog.html#improvements-8"},{"type":"extras","title":"Get Started with AshArchival","doc":"# Get Started with AshArchival","ref":"get-started-with-ash-archival.html"},{"type":"extras","title":"Installation - Get Started with AshArchival","doc":"First, add the dependency to your `mix.exs` file\n\n```elixir\n{:ash_archival, \"~> 2.0.0\"}\n```\n\nand add `:ash_archival` to your `.formatter.exs`\n\n```elixir\nimport_deps: [..., :ash_archival]\n```","ref":"get-started-with-ash-archival.html#installation"},{"type":"extras","title":"Adding to a resource - Get Started with AshArchival","doc":"To add archival to a resource, add the extension to the resource:\n\n```elixir\nuse Ash.Resource,\n  extensions: [..., AshArchival.Resource]\n```\n\nAnd thats it! Now, when you destroy a record, it will be archived instead, using an `archived_at` attribute.\n\nSee [How Does Ash Archival Work?](/documentation/topics/how-does-ash-archival-work.md) for what modifications are made to a resource, and read on for info on the tradeoffs of leveraging `d:Ash.Resource.Dsl.resource.base_filter`.","ref":"get-started-with-ash-archival.html#adding-to-a-resource"},{"type":"extras","title":"Base Filter - Get Started with AshArchival","doc":"Using a `d:Ash.Resource.Dsl.resource.base_filter` for your `archived_at` field has a lot of benefits if you are using `ash_postgres`, but comes with one major drawback, which is that it is not possible to exclude certain read actions from archival. If you wish to use a base filter, you will need to create a separate resource to read from the archived items. We may introduce a way to bypass the base filter at some point in the future.\n\nTo add a `base_filter` and `base_filter_sql` to your resource:\n\n```elixir\nresource do\n  base_filter expr(is_nil(archived_at))\nend\n\npostgres do\n  ...\n  base_filter_sql \"(archived_at IS NULL)\"\nend\n```\n\nAdd `base_filter? true` to the `archive` configuration of your resource to tell it that it doesn't need to add the filter itself.","ref":"get-started-with-ash-archival.html#base-filter"},{"type":"extras","title":"Benefits of base_filter - Get Started with AshArchival","doc":"1. unique indexes will exclude archived items\n2. custom indexes will exclude archived items\n3. check constraints will not be applied to archived items\n\nIf you want these benefits, add the appropriate `base_filter`.","ref":"get-started-with-ash-archival.html#benefits-of-base_filter"},{"type":"extras","title":"archive_related_authorize? - Get Started with AshArchival","doc":"The `archive_related_authorize?` option controls whether authorization checks are enforced when archiving related records during a destroy operation.\n\n```elixir\ndefmodule MyApp.Post do\n  use Ash.Resource,\n    extensions: [AshArchival.Resource]\n\n  archive do\n    archive_related([:comments])\n    archive_related_authorize?(false)  # Recommended: bypass authorization for related records\n  end\nend\n```\n\n**Default behavior (`archive_related_authorize?: true`):**\n- Authorization policies are enforced when archiving related records\n- If the actor lacks permission to read or destroy a record, that record will be *skipped*\n- Only related records the actor is authorized to destroy will be archived\n\n**Recommended behavior (`archive_related_authorize?: false`):**\n- Authorization checks are bypassed when archiving related records\n- All related records are archived regardless of the actor's permissions on those specific records\n- The operation succeeds even if the actor wouldn't normally be able to destroy some related records\n\n**Why set it to false?**\n\nYou typically want to set `archive_related_authorize?` to `false` because when you archive a parent record, you usually want ALL related records to be archived together, regardless of individual permissions. You typically just want to authorize the actor to archive the record in question, not all descendents.","ref":"get-started-with-ash-archival.html#archive_related_authorize"},{"type":"extras","title":"More - Get Started with AshArchival","doc":"See the [Unarchiving guide](/documentation/topics/unarchiving.md) For more.","ref":"get-started-with-ash-archival.html#more"},{"type":"extras","title":"Un-archiving","doc":"# Un-archiving\n\nIf you want to unarchive a resource that uses a base filter, you will need to define a separate resource that uses the same storage and has no base filter. The rest of this guide applies for folks who _aren't_ using a `base_filter`.\n\nUn-archiving can be accomplished by creating a read action that is skipped, using `exclude_read_actions`. Then, you can create an update action that sets that attribute to `nil`. For example:\n\n```elixir\narchive do\n  ...\n  exclude_read_actions :archived\nend\n\nactions do\n  read :archived do\n    filter expr(not is_nil(archived_at))\n  end\n\n  update :unarchive do\n    change set_attribute(:archived_at, nil)\n    # if an individual record is used to unarchive\n    # it must use the `archived` read action for its atomic upgrade\n    atomic_upgrade_with :archived\n  end\nend\n```\n\nYou could then do something like this:\n\n```elixir\nResource\n|> Ash.get!(id, action: :archived)\n|> Ash.Changeset.for_update(:unarchive, %{})\n|> Ash.update!()\n```\n\nMore idiomatically, you would define a code interfaceon the domain, and call that:\n\n```elixir\n# to unarchive by `id`\nResource\n|> Ash.Query.for_read(:archived, %{})\n|> Ash.Query.filter(id == ^id)\n|> Domain.unarchive!()\n```","ref":"unarchiving.html"},{"type":"extras","title":"Upgrading to 2.0","doc":"# Upgrading to 2.0\n\nThis guide covers the key changes when upgrading to AshArchival 2.0.","ref":"upgrading-to-2-0.html"},{"type":"extras","title":"New archive_related_authorize? Option - Upgrading to 2.0","doc":"Version 2.0 introduces the `archive_related_authorize?` configuration option that controls whether authorization checks are enforced when archiving related records.\n\n```elixir\ndefmodule MyApp.User do\n  use Ash.Resource,\n    extensions: [AshArchival.Resource]\n\n  archive do\n    archive_related([:posts, :comments])\n    archive_related_authorize?(false)  # Recommended setting\n  end\nend\n```","ref":"upgrading-to-2-0.html#new-archive_related_authorize-option"},{"type":"extras","title":"Breaking Change - Upgrading to 2.0","doc":"This is a **breaking change** because in some cases when reading records during the archival process, we previously used `authorize?: false`, but now we respect the `archive_related_authorize?` setting.\n\n**What changed:**\n- Default behavior: `archive_related_authorize?: true` (authorization is enforced)\n- Previously: authorization was inconsistently applied when reading related records for archival\n- Now: explicit control over authorization behavior","ref":"upgrading-to-2-0.html#breaking-change"},{"type":"extras","title":"Recommended Action - Upgrading to 2.0","doc":"For most applications, you should set `archive_related_authorize?: false`:\n\n```elixir\narchive do\n  archive_related([:posts, :comments])\n  archive_related_authorize?(false)\nend\n```\n\nThe reason you want it to be `false` is because you typically want to just authorize access to archive the parent record, and if that is allowed, then all related records will be archived without additional authorization checks.","ref":"upgrading-to-2-0.html#recommended-action"},{"type":"extras","title":"When to Keep Default (true) - Upgrading to 2.0","doc":"Only keep the default `true` if you need fine-grained authorization control where some related records should only be archived if the actor has explicit permission to destroy them.","ref":"upgrading-to-2-0.html#when-to-keep-default-true"},{"type":"extras","title":"How does Archival Work?","doc":"# How does Archival Work?\n\nWe make modifications to the resource to enable soft deletes. Here's a breakdown of what the extension does:","ref":"how-does-ash-archival-work.html"},{"type":"extras","title":"Resource Modifications - How does Archival Work?","doc":"1. Adds a private `archived_at` `utc_datetime_usec` attribute.\n2. Adds a preparation that filters each action for `is_nil(archived_at)` (except for excluded actions, or if you have `base_filter?` set to `true`).\n3. Marks all destroy actions as `soft?`, turning them into updates (except for excluded actions)\n4. Adds a change to all destroy actions that sets `archived_at` to the current timestamp\n5. Adds a change that will iteratively load and destroy anything configured in `d:AshArchival.Resource.archive|archive_related`","ref":"how-does-ash-archival-work.html#resource-modifications"},{"type":"extras","title":"Upserts & Identities","doc":"# Upserts & Identities\n\nIts important to consider identities when using AshArchival _without_ a `base_filter` set up.\n\nIf you are using a `base_filter`, then all identities implicitly include that `base_filter` in their\n`where` (handled by the data layer).\n\nTake the following identities, for example:\n\n```elixir\nidentities do\n  identity :unique_email, [:email], where: expr(is_nil(archived_at))\n  # and\n  identity :unique_email, [:email]\nend\n```","ref":"upserts-and-identities.html"},{"type":"extras","title":"With is_nil(archived_at) - Upserts & Identities","doc":"Using this identity allows multiple archived records with the same email, but only one _non-archived_ record per email.\nIt enables reuse of archived email addresses for new active records, maintaining data integrity by preventing duplicate\nactive records while preserving archived data.\n\nWhen you upsert a record using this identity, it will only consider active records.","ref":"upserts-and-identities.html#with-is_nil-archived_at"},{"type":"extras","title":"Without is_nil(archived_at) - Upserts & Identities","doc":"This identity configuration enforces strict email uniqueness across all records. Once an email is used, it can't be used\nagain, even after that record is archived.\n\nWhen you upsert a record using this identity, it will consider all records.","ref":"upserts-and-identities.html#without-is_nil-archived_at"},{"type":"DSL","title":"archive - dsl-asharchival-resource","doc":"A section for configuring how archival is configured for a resource.","ref":"dsl-asharchival-resource.html#archive"},{"type":"DSL","title":"archive.attribute - dsl-asharchival-resource","doc":"The attribute in which to store the archival flag (the current datetime).","ref":"dsl-asharchival-resource.html#archive-attribute"},{"type":"DSL","title":"archive.attribute_type - dsl-asharchival-resource","doc":"The attribute type.","ref":"dsl-asharchival-resource.html#archive-attribute_type"},{"type":"DSL","title":"archive.base_filter? - dsl-asharchival-resource","doc":"Whether or not a base filter exists that applies the `is_nil(archived_at)` rule.","ref":"dsl-asharchival-resource.html#archive-base_filter?"},{"type":"DSL","title":"archive.exclude_read_actions - dsl-asharchival-resource","doc":"A read action or actions that should show archived items. They will not get the automatic `is_nil(archived_at)` filter.","ref":"dsl-asharchival-resource.html#archive-exclude_read_actions"},{"type":"DSL","title":"archive.exclude_upsert_actions - dsl-asharchival-resource","doc":"This option is deprecated as it no longer has any effect. Upserts are handled according to the upsert identity. See the upserts guide for more.","ref":"dsl-asharchival-resource.html#archive-exclude_upsert_actions"},{"type":"DSL","title":"archive.exclude_destroy_actions - dsl-asharchival-resource","doc":"A destroy action or actions that should *not* archive, but instead be left alone. This allows for having a destroy *or* archive pattern.","ref":"dsl-asharchival-resource.html#archive-exclude_destroy_actions"},{"type":"DSL","title":"archive.archive_related - dsl-asharchival-resource","doc":"A list of relationships that should have all related items archived when this is archived. Notifications are not sent for this operation.","ref":"dsl-asharchival-resource.html#archive-archive_related"},{"type":"DSL","title":"archive.archive_related_authorize? - dsl-asharchival-resource","doc":"Whether or not to run authorization checks when reading and archiving related records.","ref":"dsl-asharchival-resource.html#archive-archive_related_authorize?"},{"type":"DSL","title":"archive.archive_related_arguments - dsl-asharchival-resource","doc":"A function to allow passing along some of the arguments to related resources when archiving them.","ref":"dsl-asharchival-resource.html#archive-archive_related_arguments"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}